require '_h2ph_pre.ph';

unless(defined(&__ASM_SYSTEM_H)) {
    eval 'sub __ASM_SYSTEM_H () {1;}' unless defined(&__ASM_SYSTEM_H);
    require 'linux/kernel.ph';
    require 'asm/segment.ph';
    if(defined(&__KERNEL__)) {
	eval 'sub switch_to {
	    local($prev,$next,$last) = @_;
    	    eval q( &do {  &asm  &volatile(\\"pushl %%esi\\\\n\\\\t\\" \\"pushl %%edi\\\\n\\\\t\\" \\"pushl %%ebp\\\\n\\\\t\\" \\"movl %%esp,%0\\\\n\\\\t\\" \\"movl %3,%%esp\\\\n\\\\t\\" \\"movl $1f,%1\\\\n\\\\t\\" \\"pushl %4\\\\n\\\\t\\" \\"jmp __switch_to\\\\n\\" \\"1:\\\\t\\" \\"popl %%ebp\\\\n\\\\t\\" \\"popl %%edi\\\\n\\\\t\\" \\"popl %%esi\\\\n\\\\t\\" :\\"=m\\" ( ($prev->{tss}->{esp})),\\"=m\\" ( ($prev->{tss}->{eip})), \\"=b\\" ($last) :\\"m\\" ( ($next->{tss}->{esp})),\\"m\\" ( ($next->{tss}->{eip})), \\"a\\" ($prev), \\"d\\" ($next), \\"b\\" ($prev)); }  &while (0));
	}' unless defined(&switch_to);
	eval 'sub _set_base {
	    local($addr,$base) = @_;
    	    eval q( &do { \'unsigned long __pr\';  &__asm__  &__volatile__ (\\"movw %%dx,%1\\\\n\\\\t\\" \\"rorl $16,%%edx\\\\n\\\\t\\" \\"movb %%dl,%2\\\\n\\\\t\\" \\"movb %%dh,%3\\" :\\"=&d\\" ( &__pr) :\\"m\\" (*(($addr)+2)), \\"m\\" (*(($addr)+4)), \\"m\\" (*(($addr)+7)), \\"0\\" ($base) ); }  &while(0));
	}' unless defined(&_set_base);
	eval 'sub _set_limit {
	    local($addr,$limit) = @_;
    	    eval q( &do { \'unsigned long __lr\';  &__asm__  &__volatile__ (\\"movw %%dx,%1\\\\n\\\\t\\" \\"rorl $16,%%edx\\\\n\\\\t\\" \\"movb %2,%%dh\\\\n\\\\t\\" \\"andb $0xf0,%%dh\\\\n\\\\t\\" \\"orb %%dh,%%dl\\\\n\\\\t\\" \\"movb %%dl,%2\\" :\\"=&d\\" ( &__lr) :\\"m\\" (*($addr)), \\"m\\" (*(($addr)+6)), \\"0\\" ($limit) ); }  &while(0));
	}' unless defined(&_set_limit);
	eval 'sub set_base {
	    local($ldt,$base) = @_;
    	    eval q( &_set_base( (($ldt)) , ($base) ));
	}' unless defined(&set_base);
	eval 'sub set_limit {
	    local($ldt,$limit) = @_;
    	    eval q( &_set_limit( (($ldt)) , (($limit)-1)>>12));
	}' unless defined(&set_limit);
	eval 'sub get_base {
	    local($ldt) = @_;
    	    eval q( &_get_base( (($ldt)) ));
	}' unless defined(&get_base);
	eval 'sub loadsegment {
	    local($seg,$value) = @_;
    	    eval q( &asm  &volatile(\\"\\\\n\\" \\"1:\\\\t\\" \\"movl %0,%%\\" $seg \\"\\\\n\\" \\"2:\\\\n\\" \\".section .fixup,\\\\\\"ax\\\\\\"\\\\n\\" \\"3:\\\\t\\" \\"pushl $0\\\\n\\\\t\\" \\"popl %%\\" $seg \\"\\\\n\\\\t\\" \\"jmp 2b\\\\n\\" \\".previous\\\\n\\" \\".section __ex_table,\\\\\\"a\\\\\\"\\\\n\\\\t\\" \\".align 4\\\\n\\\\t\\" \\".long 1b,3b\\\\n\\" \\".previous\\" : :\\"m\\" (*($value))));
	}' unless defined(&loadsegment);
	eval 'sub clts () {
	    eval q( &__asm__  &__volatile__ (\\"clts\\"));
	}' unless defined(&clts);
	eval 'sub read_cr0 () {
	    eval q(({ \'unsigned int __dummy\';  &__asm__( \\"movl %%cr0,%0\\\\n\\\\t\\" :\\"=r\\" ( &__dummy));  &__dummy; }));
	}' unless defined(&read_cr0);
	eval 'sub write_cr0 {
	    local($x) = @_;
    	    eval q( &__asm__(\\"movl %0,%%cr0\\": :\\"r\\" ($x)););
	}' unless defined(&write_cr0);
	eval 'sub stts () {
	    eval q( &write_cr0(8|  &read_cr0()));
	}' unless defined(&stts);
    }
    eval 'sub nop () {
        eval q( &__asm__  &__volatile__ (\\"nop\\"));
    }' unless defined(&nop);
    eval 'sub xchg {
        local($ptr,$x) = @_;
	    eval q((( &__typeof__(*)) &__xchg(($x),($ptr),$sizeof{($ptr)})));
    }' unless defined(&xchg);
    eval 'sub tas {
        local($ptr) = @_;
	    eval q(( &xchg(($ptr),1)));
    }' unless defined(&tas);
    eval 'sub __xg {
        local($x) = @_;
	    eval q((($x)));
    }' unless defined(&__xg);
    eval 'sub mb () {
        eval q( &__asm__  &__volatile__ (\\"lock; addl $0,0(%%esp)\\": : :\\"memory\\"));
    }' unless defined(&mb);
    eval 'sub rmb () {
        eval q( &mb());
    }' unless defined(&rmb);
    eval 'sub wmb () {
        eval q( &__asm__  &__volatile__ (\\"\\": : :\\"memory\\"));
    }' unless defined(&wmb);
    eval 'sub __sti () {
        eval q( &__asm__  &__volatile__ (\\"sti\\": : :\\"memory\\"));
    }' unless defined(&__sti);
    eval 'sub __cli () {
        eval q( &__asm__  &__volatile__ (\\"cli\\": : :\\"memory\\"));
    }' unless defined(&__cli);
    eval 'sub __save_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"pushfl ; popl %0\\":\\"=g\\" ($x): :\\"memory\\"));
    }' unless defined(&__save_flags);
    eval 'sub __restore_flags {
        local($x) = @_;
	    eval q( &__asm__  &__volatile__(\\"pushl %0 ; popfl\\": :\\"g\\" ($x):\\"memory\\"));
    }' unless defined(&__restore_flags);
    if(defined(&__SMP__)) {
	eval 'sub cli () {
	    eval q( &__global_cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__global_sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($x) = @_;
    	    eval q((($x)= &__global_save_flags()));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($x) = @_;
    	    eval q( &__global_restore_flags($x));
	}' unless defined(&restore_flags);
    } else {
	eval 'sub cli () {
	    eval q( &__cli());
	}' unless defined(&cli);
	eval 'sub sti () {
	    eval q( &__sti());
	}' unless defined(&sti);
	eval 'sub save_flags {
	    local($x) = @_;
    	    eval q( &__save_flags($x));
	}' unless defined(&save_flags);
	eval 'sub restore_flags {
	    local($x) = @_;
    	    eval q( &__restore_flags($x));
	}' unless defined(&restore_flags);
    }
    eval 'sub HAVE_DISABLE_HLT () {1;}' unless defined(&HAVE_DISABLE_HLT);
}
1;
