require '_h2ph_pre.ph';

unless(defined(&_KERN_COMPAT_H)) {
    eval 'sub _KERN_COMPAT_H () {1;}' unless defined(&_KERN_COMPAT_H);
    if(! defined( &LINUX_VERSION_CODE) || ((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x10000)) {
	require 'linux/version.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20300  && defined( &MODVERSIONS)) {
	require 'linux/modversions.ph';
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20100  && ! defined( &__alpha__)) {
	eval 'sub ioremap {
	    local($a,$b) = @_;
    	    eval q((( >= 0x100000) ?  &vremap($a,$b) : ($a)));
	}' unless defined(&ioremap);
	eval 'sub iounmap {
	    local($v) = @_;
    	    eval q( &do {  &if (($v) >= 0x100000)  &vfree($v);}  &while (0));
	}' unless defined(&iounmap);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20115) {
	eval 'sub MODULE_AUTHOR {
	    local($name) = @_;
    	    eval q( &extern \'int\'  &nonesuch);
	}' unless defined(&MODULE_AUTHOR);
	eval 'sub MODULE_DESCRIPTION {
	    local($string) = @_;
    	    eval q( &extern \'int\'  &nonesuch);
	}' unless defined(&MODULE_DESCRIPTION);
	eval 'sub MODULE_PARM {
	    local($varname, $typestring) = @_;
    	    eval q( &extern \'int\'  &nonesuch);
	}' unless defined(&MODULE_PARM);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20123) {
	eval 'sub hard_smp_processor_id () {
	    eval q( &smp_processor_id());
	}' unless defined(&hard_smp_processor_id);
	eval 'sub test_and_set_bit {
	    local($val, $addr) = @_;
    	    eval q( &set_bit($val, $addr));
	}' unless defined(&test_and_set_bit);
	eval 'sub le16_to_cpu {
	    local($val) = @_;
    	    eval q(($val));
	}' unless defined(&le16_to_cpu);
	eval 'sub cpu_to_le16 {
	    local($val) = @_;
    	    eval q(($val));
	}' unless defined(&cpu_to_le16);
	eval 'sub le16_to_cpus {
	    local($val) = @_;
    	    eval q();
	}' unless defined(&le16_to_cpus);
	eval 'sub le32_to_cpu {
	    local($val) = @_;
    	    eval q(($val));
	}' unless defined(&le32_to_cpu);
	eval 'sub cpu_to_le32 {
	    local($val) = @_;
    	    eval q(($val));
	}' unless defined(&cpu_to_le32);
	eval 'sub SPIN_LOCK_UNLOCKED () {0;}' unless defined(&SPIN_LOCK_UNLOCKED);
	eval 'sub spin_lock {
	    local($lock) = @_;
    	    eval q();
	}' unless defined(&spin_lock);
	eval 'sub spin_unlock {
	    local($lock) = @_;
    	    eval q();
	}' unless defined(&spin_unlock);
	eval 'sub spin_lock_irqsave {
	    local($lock, $flags) = @_;
    	    eval q( &save_flags($flags);  &cli(););
	}' unless defined(&spin_lock_irqsave);
	eval 'sub spin_unlock_irqrestore {
	    local($lock, $flags) = @_;
    	    eval q( &restore_flags($flags););
	}' unless defined(&spin_unlock_irqrestore);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) <= 0x20139) {
	eval 'sub net_device_stats () { &enet_statistics;}' unless defined(&net_device_stats);
    } else {
	eval 'sub NETSTATS_VER2 () {1;}' unless defined(&NETSTATS_VER2);
    }
    unless(defined(&SIOCGMIIPHY)) {
	eval 'sub SIOCGMIIPHY () {( &SIOCDEVPRIVATE);}' unless defined(&SIOCGMIIPHY);
	eval 'sub SIOCGMIIREG () {( &SIOCDEVPRIVATE+1);}' unless defined(&SIOCGMIIREG);
	eval 'sub SIOCSMIIREG () {( &SIOCDEVPRIVATE+2);}' unless defined(&SIOCSMIIREG);
	eval 'sub SIOCGPARAMS () {( &SIOCDEVPRIVATE+3);}' unless defined(&SIOCGPARAMS);
	eval 'sub SIOCSPARAMS () {( &SIOCDEVPRIVATE+4);}' unless defined(&SIOCSPARAMS);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20155) {
	require 'linux/bios32.ph';
	eval 'sub PCI_SUPPORT_VER1 () {1;}' unless defined(&PCI_SUPPORT_VER1);
	if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20020) {
	}
	eval 'sub pci_find_slot {
	    local($bus, $devfn) = @_;
    	    eval q((($bus<<8) | $devfn | 0xf0000));
	}' unless defined(&pci_find_slot);
	eval 'sub bus_number {
	    local($pci_dev) = @_;
    	    eval q((((($pci_dev))>>8) & 0xff));
	}' unless defined(&bus_number);
	eval 'sub devfn_number {
	    local($pci_dev) = @_;
    	    eval q(((($pci_dev)) & 0xff));
	}' unless defined(&devfn_number);
	unless(defined(&CONFIG_PCI)) {
	} else {
	    eval 'sub pci_present () { &pcibios_present;}' unless defined(&pci_present);
	}
	eval 'sub pci_read_config_byte {
	    local($pdev, $where, $valp) = @_;
    	    eval q( &pcibios_read_config_byte( &bus_number($pdev),  &devfn_number($pdev), $where, $valp));
	}' unless defined(&pci_read_config_byte);
	eval 'sub pci_read_config_word {
	    local($pdev, $where, $valp) = @_;
    	    eval q( &pcibios_read_config_word( &bus_number($pdev),  &devfn_number($pdev), $where, $valp));
	}' unless defined(&pci_read_config_word);
	eval 'sub pci_read_config_dword {
	    local($pdev, $where, $valp) = @_;
    	    eval q( &pcibios_read_config_dword( &bus_number($pdev),  &devfn_number($pdev), $where, $valp));
	}' unless defined(&pci_read_config_dword);
	eval 'sub pci_write_config_byte {
	    local($pdev, $where, $val) = @_;
    	    eval q( &pcibios_write_config_byte( &bus_number($pdev),  &devfn_number($pdev), $where, $val));
	}' unless defined(&pci_write_config_byte);
	eval 'sub pci_write_config_word {
	    local($pdev, $where, $val) = @_;
    	    eval q( &pcibios_write_config_word( &bus_number($pdev),  &devfn_number($pdev), $where, $val));
	}' unless defined(&pci_write_config_word);
	eval 'sub pci_write_config_dword {
	    local($pdev, $where, $val) = @_;
    	    eval q( &pcibios_write_config_dword( &bus_number($pdev),  &devfn_number($pdev), $where, $val));
	}' unless defined(&pci_write_config_dword);
    } else {
	eval 'sub PCI_SUPPORT_VER2 () {1;}' unless defined(&PCI_SUPPORT_VER2);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x20159) {
	eval 'sub dev_free_skb {
	    local($skb) = @_;
    	    eval q( &dev_kfree_skb($skb,  &FREE_WRITE););
	}' unless defined(&dev_free_skb);
    } else {
	eval 'sub dev_free_skb {
	    local($skb) = @_;
    	    eval q( &dev_kfree_skb($skb););
	}' unless defined(&dev_free_skb);
    }
    if((defined(&LINUX_VERSION_CODE) ? &LINUX_VERSION_CODE : 0) < 0x2030d) {
	eval 'sub net_device () { &device;}' unless defined(&net_device);
    }
    if(! defined( &CAP_NET_ADMIN)) {
	eval 'sub capable {
	    local($CAP_XXX) = @_;
    	    eval q(( &suser()));
	}' unless defined(&capable);
    }
    if(! defined( &HAS_NETIF_QUEUE)) {
	eval 'sub netif_wake_queue {
	    local($dev) = @_;
    	    eval q( &mark_bh( &NET_BH));
	}' unless defined(&netif_wake_queue);
	eval 'sub netif_start_tx_queue {
	    local($dev) = @_;
    	    eval q(($dev)-> &tbusy = 0);
	}' unless defined(&netif_start_tx_queue);
	eval 'sub netif_stop_tx_queue {
	    local($dev) = @_;
    	    eval q(($dev)-> &tbusy = 1);
	}' unless defined(&netif_stop_tx_queue);
	eval 'sub netif_queue_paused {
	    local($dev) = @_;
    	    eval q((($dev)-> &tbusy != 0));
	}' unless defined(&netif_queue_paused);
	eval 'sub netif_pause_tx_queue {
	    local($dev) = @_;
    	    eval q(( &test_and_set_bit(0, ( &void*)($dev)-> &tbusy)));
	}' unless defined(&netif_pause_tx_queue);
	eval 'sub netif_unpause_tx_queue {
	    local($dev) = @_;
    	    eval q( &do {  &clear_bit(0, ( &void*)($dev)-> &tbusy); }  &while (0));
	}' unless defined(&netif_unpause_tx_queue);
	eval 'sub netif_resume_tx_queue {
	    local($dev) = @_;
    	    eval q( &do {  &clear_bit(0, ( &void*)($dev)-> &tbusy);  &mark_bh( &NET_BH); }  &while (0));
	}' unless defined(&netif_resume_tx_queue);
    }
}
1;
