require '_h2ph_pre.ph';

unless(defined(&_LINUX_REISER_FS_H)) {
    eval 'sub _LINUX_REISER_FS_H () {1;}' unless defined(&_LINUX_REISER_FS_H);
    require 'linux/types.ph';
    if(defined(&__KERNEL__)) {
	require 'linux/malloc.ph';
	require 'linux/tqueue.ph';
    }
    eval 'sub REISERFS_CHECK () {1;}' unless defined(&REISERFS_CHECK);
    eval 'sub OLD_GET_NEW_BUFFER () {1;}' unless defined(&OLD_GET_NEW_BUFFER);
    eval 'sub DIRTY_LATER () {1;}' unless defined(&DIRTY_LATER);
    eval 'sub REISERFS_NBUF () {32;}' unless defined(&REISERFS_NBUF);
    eval 'sub REISERFS_OBJECT_READ_AHEAD () {1;}' unless defined(&REISERFS_OBJECT_READ_AHEAD);
    eval 'sub PACKING_LOCALITY_READ_AHEAD () {1;}' unless defined(&PACKING_LOCALITY_READ_AHEAD);
    eval 'sub REISERFS_SUPER_MAGIC () {0x52654973;}' unless defined(&REISERFS_SUPER_MAGIC);
    eval 'sub REISERFS_SUPER_MAGIC_STRING () {"ReIsErFs";}' unless defined(&REISERFS_SUPER_MAGIC_STRING);
    eval 'sub REISERFS_DISK_OFFSET_IN_BYTES () {(64* 1024);}' unless defined(&REISERFS_DISK_OFFSET_IN_BYTES);
    eval 'sub REISERFS_FIRST_BLOCK () { &unused_define;}' unless defined(&REISERFS_FIRST_BLOCK);
    eval 'sub REISERFS_OLD_DISK_OFFSET_IN_BYTES () {(8* 1024);}' unless defined(&REISERFS_OLD_DISK_OFFSET_IN_BYTES);
    eval 'sub READ_BLOCKS () {1;}' unless defined(&READ_BLOCKS);
    eval 'sub DONT_READ_BLOCKS () {2;}' unless defined(&DONT_READ_BLOCKS);
    eval 'sub CARRY_ON () {0;}' unless defined(&CARRY_ON);
    eval 'sub SCHEDULE_OCCURRED () {1;}' unless defined(&SCHEDULE_OCCURRED);
    eval 'sub PATH_INCORRECT () {2;}' unless defined(&PATH_INCORRECT);
    eval 'sub IO_ERROR () {3;}' unless defined(&IO_ERROR);
    eval 'sub NO_DISK_SPACE () {(-1);}' unless defined(&NO_DISK_SPACE);
    eval 'sub NO_BALANCING_NEEDED () {(-2);}' unless defined(&NO_BALANCING_NEEDED);
    eval 'sub MIN_PACK_ON_CLOSE () {512;}' unless defined(&MIN_PACK_ON_CLOSE);
    eval 'sub DIRECT_TAIL_SUPPRESSION_SIZE () {1024;}' unless defined(&DIRECT_TAIL_SUPPRESSION_SIZE);
    eval 'sub MAX_BYTES_SUPPRESS_DIRECT_TAIL () {1024;}' unless defined(&MAX_BYTES_SUPPRESS_DIRECT_TAIL);
    eval 'sub INODE_OFFSET_IN_DIRECT {
        local($p_s_inode, $n_offset) = @_;
	    eval q(( ($n_offset) >= ($p_s_inode)-> ($u->{reiserfs_i}->{i_first_direct_byte}) ));
    }' unless defined(&INODE_OFFSET_IN_DIRECT);
    eval 'sub NO_BYTES_IN_DIRECT_ITEM () { &MAX_KEY_OFFSET;}' unless defined(&NO_BYTES_IN_DIRECT_ITEM);
    eval 'sub STORE_TAIL_IN_UNFM {
        local($n_file_size,$n_tail_size,$n_block_size) = @_;
	    eval q(( (($n_tail_size) >  &MAX_DIRECT_ITEM_LEN($n_block_size)) || ( ($n_file_size) >= ($n_block_size) * 4) || ( ( ($n_file_size) >= ($n_block_size) * 3)  && ( ($n_tail_size) >= ( &MAX_DIRECT_ITEM_LEN($n_block_size))/4) ) || ( ( ($n_file_size) >= ($n_block_size) * 2)  && ( ($n_tail_size) >= ( &MAX_DIRECT_ITEM_LEN($n_block_size))/2) ) || ( ( ($n_file_size) >= ($n_block_size) )  && ( ($n_tail_size) >= ( &MAX_DIRECT_ITEM_LEN($n_block_size) * 3)/4) ) ));
    }' unless defined(&STORE_TAIL_IN_UNFM);
    eval 'sub REISERFS_VALID_FS () {1;}' unless defined(&REISERFS_VALID_FS);
    eval 'sub REISERFS_ERROR_FS () {2;}' unless defined(&REISERFS_ERROR_FS);
    eval 'sub REISERFS_FULL_KEY_LEN () {4;}' unless defined(&REISERFS_FULL_KEY_LEN);
    eval 'sub REISERFS_SHORT_KEY_LEN () {2;}' unless defined(&REISERFS_SHORT_KEY_LEN);
    eval 'sub FIRST_GREATER () {1;}' unless defined(&FIRST_GREATER);
    eval 'sub SECOND_GREATER () {-1;}' unless defined(&SECOND_GREATER);
    eval 'sub KEYS_IDENTICAL () {0;}' unless defined(&KEYS_IDENTICAL);
    eval 'sub KEY_FOUND () {1;}' unless defined(&KEY_FOUND);
    eval 'sub KEY_NOT_FOUND () {0;}' unless defined(&KEY_NOT_FOUND);
    eval 'sub KEY_SIZE () {($sizeof{\'struct key\'});}' unless defined(&KEY_SIZE);
    eval 'sub SHORT_KEY_SIZE () {($sizeof{\'unsigned long\'} + $sizeof{\'unsigned long\'});}' unless defined(&SHORT_KEY_SIZE);
    eval 'sub ITEM_FOUND () {1;}' unless defined(&ITEM_FOUND);
    eval 'sub ITEM_NOT_FOUND () {0;}' unless defined(&ITEM_NOT_FOUND);
    eval 'sub ENTRY_FOUND () {1;}' unless defined(&ENTRY_FOUND);
    eval 'sub ENTRY_NOT_FOUND () {0;}' unless defined(&ENTRY_NOT_FOUND);
    eval 'sub DIRECTORY_NOT_FOUND () {-1;}' unless defined(&DIRECTORY_NOT_FOUND);
    eval 'sub REGULAR_FILE_FOUND () {-2;}' unless defined(&REGULAR_FILE_FOUND);
    eval 'sub DIRECTORY_FOUND () {-3;}' unless defined(&DIRECTORY_FOUND);
    eval 'sub BYTE_FOUND () {1;}' unless defined(&BYTE_FOUND);
    eval 'sub BYTE_NOT_FOUND () {0;}' unless defined(&BYTE_NOT_FOUND);
    eval 'sub FILE_NOT_FOUND () {-1;}' unless defined(&FILE_NOT_FOUND);
    eval 'sub POSITION_FOUND () {1;}' unless defined(&POSITION_FOUND);
    eval 'sub POSITION_NOT_FOUND () {0;}' unless defined(&POSITION_NOT_FOUND);
    eval 'sub GOTO_PREVIOUS_ITEM () {2;}' unless defined(&GOTO_PREVIOUS_ITEM);
    eval 'sub POSITION_FOUND_INVISIBLE () {3;}' unless defined(&POSITION_FOUND_INVISIBLE);
    eval 'sub IH_SIZE () {($sizeof{\'struct item_head\'});}' unless defined(&IH_SIZE);
    eval 'sub ih_item_len {
        local($ih) = @_;
	    eval q(( &__le16_to_cpu(($ih)-> &ih_item_len)));
    }' unless defined(&ih_item_len);
    eval 'sub I_K_KEY_IN_ITEM {
        local($p_s_ih, $p_s_key, $n_blocksize) = @_;
	    eval q(( !  &COMP_SHORT_KEYS($p_s_ih, $p_s_key)  &&  &I_OFF_BYTE_IN_ITEM($p_s_ih, ($p_s_key)-> &k_offset, $n_blocksize) ));
    }' unless defined(&I_K_KEY_IN_ITEM);
    eval 'sub MAX_ITEM_LEN {
        local($block_size) = @_;
	    eval q(($block_size -  &BLKH_SIZE -  &IH_SIZE));
    }' unless defined(&MAX_ITEM_LEN);
    eval 'sub MIN_ITEM_LEN () {1;}' unless defined(&MIN_ITEM_LEN);
    eval 'sub REISERFS_ROOT_OBJECTID () {2;}' unless defined(&REISERFS_ROOT_OBJECTID);
    eval 'sub REISERFS_ROOT_PARENT_OBJECTID () {1;}' unless defined(&REISERFS_ROOT_PARENT_OBJECTID);
    eval 'sub BLKH_SIZE () {($sizeof{\'struct block_head\'});}' unless defined(&BLKH_SIZE);
    eval 'sub FREE_LEVEL () {0;}' unless defined(&FREE_LEVEL);
    eval 'sub DISK_LEAF_NODE_LEVEL () {1;}' unless defined(&DISK_LEAF_NODE_LEVEL);
    eval 'sub B_BLK_HEAD {
        local($p_s_bh) = @_;
	    eval q(((($p_s_bh)-> &b_data)));
    }' unless defined(&B_BLK_HEAD);
    eval 'sub B_NR_ITEMS {
        local($p_s_bh) = @_;
	    eval q((  &B_BLK_HEAD($p_s_bh)-> &blk_nr_item ));
    }' unless defined(&B_NR_ITEMS);
    eval 'sub B_LEVEL {
        local($bh) = @_;
	    eval q((  &B_BLK_HEAD($bh)-> &blk_level ));
    }' unless defined(&B_LEVEL);
    eval 'sub B_FREE_SPACE {
        local($bh) = @_;
	    eval q((  &B_BLK_HEAD($bh)-> &blk_free_space ));
    }' unless defined(&B_FREE_SPACE);
    eval 'sub B_PRIGHT_DELIM_KEY {
        local($p_s_bh) = @_;
	    eval q(( ( &B_BLK_HEAD($p_s_bh)-> &blk_right_delim_key) ));
    }' unless defined(&B_PRIGHT_DELIM_KEY);
    eval 'sub B_IS_ITEMS_LEVEL {
        local($p_s_bh) = @_;
	    eval q((  &B_BLK_HEAD($p_s_bh)-> &blk_level ==  &DISK_LEAF_NODE_LEVEL ));
    }' unless defined(&B_IS_ITEMS_LEVEL);
    eval 'sub B_IS_KEYS_LEVEL {
        local($p_s_bh) = @_;
	    eval q((  &B_BLK_HEAD($p_s_bh)-> &blk_level >  &DISK_LEAF_NODE_LEVEL  &&  &B_BLK_HEAD($p_s_bh)-> &blk_level <=  &MAX_HEIGHT ));
    }' unless defined(&B_IS_KEYS_LEVEL);
    eval 'sub SD_SIZE () {($sizeof{\'struct stat_data\'});}' unless defined(&SD_SIZE);
    eval 'sub SD_OFFSET () {0;}' unless defined(&SD_OFFSET);
    eval 'sub SD_UNIQUENESS () {0;}' unless defined(&SD_UNIQUENESS);
    eval 'sub DOT_OFFSET () {1;}' unless defined(&DOT_OFFSET);
    eval 'sub DOT_DOT_OFFSET () {2;}' unless defined(&DOT_DOT_OFFSET);
    eval 'sub DIRENTRY_UNIQUENESS () {500;}' unless defined(&DIRENTRY_UNIQUENESS);
    eval 'sub FIRST_ITEM_OFFSET () {1;}' unless defined(&FIRST_ITEM_OFFSET);
    eval 'sub DEH_SIZE () {$sizeof{\'struct reiserfs_de_head\'};}' unless defined(&DEH_SIZE);
    eval 'sub deh_offset {
        local($deh) = @_;
	    eval q(( &__le32_to_cpu (($deh)-> &deh_offset)));
    }' unless defined(&deh_offset);
    eval 'sub deh_dir_id {
        local($deh) = @_;
	    eval q(( &__le32_to_cpu (($deh)-> &deh_dir_id)));
    }' unless defined(&deh_dir_id);
    eval 'sub deh_objectid {
        local($deh) = @_;
	    eval q(( &__le32_to_cpu (($deh)-> &deh_objectid)));
    }' unless defined(&deh_objectid);
    eval 'sub deh_location {
        local($deh) = @_;
	    eval q(( &__le16_to_cpu (($deh)-> &deh_location)));
    }' unless defined(&deh_location);
    eval 'sub DEH_Statdata () {0;}' unless defined(&DEH_Statdata);
    eval 'sub DEH_Visible () {2;}' unless defined(&DEH_Visible);
    eval 'sub mark_de_with_sd {
        local($deh) = @_;
	    eval q( &set_bit ( &DEH_Statdata, (($deh)-> &deh_state)));
    }' unless defined(&mark_de_with_sd);
    eval 'sub mark_de_without_sd {
        local($deh) = @_;
	    eval q( &clear_bit ( &DEH_Statdata, (($deh)-> &deh_state)));
    }' unless defined(&mark_de_without_sd);
    eval 'sub mark_de_visible {
        local($deh) = @_;
	    eval q( &set_bit ( &DEH_Visible, (($deh)-> &deh_state)));
    }' unless defined(&mark_de_visible);
    eval 'sub mark_de_hidden {
        local($deh) = @_;
	    eval q( &clear_bit ( &DEH_Visible, (($deh)-> &deh_state)));
    }' unless defined(&mark_de_hidden);
    eval 'sub de_with_sd {
        local($deh) = @_;
	    eval q( &test_bit ( &DEH_Statdata, (($deh)-> &deh_state)));
    }' unless defined(&de_with_sd);
    eval 'sub de_visible {
        local($deh) = @_;
	    eval q( &test_bit ( &DEH_Visible, (($deh)-> &deh_state)));
    }' unless defined(&de_visible);
    eval 'sub de_hidden {
        local($deh) = @_;
	    eval q(! &test_bit ( &DEH_Visible, (($deh)-> &deh_state)));
    }' unless defined(&de_hidden);
    eval 'sub I_DEH_N_ENTRY_LENGTH {
        local($ih,$deh,$i) = @_;
	    eval q((($i) ? ((($deh)-1)-> &deh_location - ($deh)-> &deh_location) : (($ih)-> &ih_item_len) - ($deh)-> &deh_location));
    }' unless defined(&I_DEH_N_ENTRY_LENGTH);
    eval 'sub EMPTY_DIR_SIZE () {(2*  &DEH_SIZE + 3);}' unless defined(&EMPTY_DIR_SIZE);
    eval 'sub I_ENTRY_COUNT {
        local($ih) = @_;
	    eval q((($ih)-> ($u->{ih_entry_count})));
    }' unless defined(&I_ENTRY_COUNT);
    eval 'sub B_I_DEH {
        local($bh,$ih) = @_;
	    eval q((( &B_I_PITEM($bh,$ih))));
    }' unless defined(&B_I_DEH);
    eval 'sub B_I_E_NAME {
        local($entry_num,$bh,$ih) = @_;
	    eval q((( ($bh->{b_data}) +  ($ih->{ih_item_location}) + ( &B_I_DEH($bh,$ih)+($entry_num))-> &deh_location)));
    }' unless defined(&B_I_E_NAME);
    eval 'sub REISERFS_MAX_NAME_LEN {
        local($block_size) = @_;
	    eval q(($block_size -  &BLKH_SIZE -  &IH_SIZE -  &DEH_SIZE));
    }' unless defined(&REISERFS_MAX_NAME_LEN);
    eval 'sub B_I_DEH_ENTRY_FILE_NAME {
        local($bh,$ih,$deh) = @_;
	    eval q(( &B_I_PITEM ($bh, $ih) + ($deh)-> &deh_location));
    }' unless defined(&B_I_DEH_ENTRY_FILE_NAME);
    eval 'sub I_DEH_N_ENTRY_FILE_NAME_LENGTH {
        local($ih,$deh,$entry_num) = @_;
	    eval q(( &I_DEH_N_ENTRY_LENGTH ($ih, $deh, $entry_num) - ( &de_with_sd ($deh) ?  &SD_SIZE : 0)));
    }' unless defined(&I_DEH_N_ENTRY_FILE_NAME_LENGTH);
    eval 'sub DEH_OBJECTID {
        local($deh) = @_;
	    eval q((($deh)-> &deh_objectid));
    }' unless defined(&DEH_OBJECTID);
    eval 'sub GET_HASH_VALUE {
        local($offset) = @_;
	    eval q((($offset) & 0x7fffff80));
    }' unless defined(&GET_HASH_VALUE);
    eval 'sub GET_GENERATION_NUMBER {
        local($offset) = @_;
	    eval q((($offset) & 0x0000007f));
    }' unless defined(&GET_GENERATION_NUMBER);
    eval 'sub DC_SIZE () {($sizeof{\'struct disk_child\'});}' unless defined(&DC_SIZE);
    eval 'sub B_N_CHILD {
        local($p_s_bh,$n_pos) = @_;
	    eval q(((($p_s_bh)-> &b_data+ &BLKH_SIZE+ &B_NR_ITEMS($p_s_bh)* &KEY_SIZE+ &DC_SIZE*($n_pos))));
    }' unless defined(&B_N_CHILD);
    eval 'sub B_N_CHILD_NUM {
        local($p_s_bh,$n_pos) = @_;
	    eval q(( &B_N_CHILD($p_s_bh,$n_pos)-> &dc_block_number));
    }' unless defined(&B_N_CHILD_NUM);
    eval 'sub MAX_CHILD_SIZE {
        local($bh) = @_;
	    eval q((( ($bh)-> &b_size -  &BLKH_SIZE )));
    }' unless defined(&MAX_CHILD_SIZE);
    eval 'sub B_CHILD_SIZE {
        local($cur) = @_;
	    eval q(( &MAX_CHILD_SIZE($cur)-( &B_FREE_SPACE($cur))));
    }' unless defined(&B_CHILD_SIZE);
    eval 'sub MAX_NR_KEY {
        local($bh) = @_;
	    eval q(( ( &MAX_CHILD_SIZE($bh)- &DC_SIZE)/( &KEY_SIZE+ &DC_SIZE) ));
    }' unless defined(&MAX_NR_KEY);
    eval 'sub MIN_NR_KEY {
        local($bh) = @_;
	    eval q(( &MAX_NR_KEY($bh)/2));
    }' unless defined(&MIN_NR_KEY);
    eval 'sub MAX_HEIGHT () {5;}' unless defined(&MAX_HEIGHT);
    eval 'sub EXTENDED_MAX_HEIGHT () {7;}' unless defined(&EXTENDED_MAX_HEIGHT);
    eval 'sub FIRST_PATH_ELEMENT_OFFSET () {2;}' unless defined(&FIRST_PATH_ELEMENT_OFFSET);
    eval 'sub ILLEGAL_PATH_ELEMENT_OFFSET () {1;}' unless defined(&ILLEGAL_PATH_ELEMENT_OFFSET);
    eval 'sub MAX_FEB_SIZE () {6;}' unless defined(&MAX_FEB_SIZE);
    eval 'sub PATH_OFFSET_PELEMENT {
        local($p_s_path,$n_offset) = @_;
	    eval q((($p_s_path)-> &path_elements +($n_offset)));
    }' unless defined(&PATH_OFFSET_PELEMENT);
    eval 'sub PATH_OFFSET_PBUFFER {
        local($p_s_path,$n_offset) = @_;
	    eval q(( &PATH_OFFSET_PELEMENT($p_s_path,$n_offset)-> &pe_buffer));
    }' unless defined(&PATH_OFFSET_PBUFFER);
    eval 'sub PATH_OFFSET_POSITION {
        local($p_s_path,$n_offset) = @_;
	    eval q(( &PATH_OFFSET_PELEMENT($p_s_path,$n_offset)-> &pe_position));
    }' unless defined(&PATH_OFFSET_POSITION);
    eval 'sub PATH_PLAST_BUFFER {
        local($p_s_path) = @_;
	    eval q(( &PATH_OFFSET_PBUFFER(($p_s_path), ($p_s_path)-> &path_length)));
    }' unless defined(&PATH_PLAST_BUFFER);
    eval 'sub PATH_LAST_POSITION {
        local($p_s_path) = @_;
	    eval q(( &PATH_OFFSET_POSITION(($p_s_path), ($p_s_path)-> &path_length)));
    }' unless defined(&PATH_LAST_POSITION);
    eval 'sub PATH_PITEM_HEAD {
        local($p_s_path) = @_;
	    eval q( &B_N_PITEM_HEAD( &PATH_PLAST_BUFFER($p_s_path), &PATH_LAST_POSITION($p_s_path)));
    }' unless defined(&PATH_PITEM_HEAD);
    eval 'sub PATH_H_PBUFFER {
        local($p_s_path, $h) = @_;
	    eval q( &PATH_OFFSET_PBUFFER ($p_s_path,  ($p_s_path->{path_length}) - ($h)));
    }' unless defined(&PATH_H_PBUFFER);
    eval 'sub PATH_H_PPARENT {
        local($path, $h) = @_;
	    eval q( &PATH_H_PBUFFER ($path, ($h) + 1));
    }' unless defined(&PATH_H_PPARENT);
    eval 'sub PATH_H_POSITION {
        local($path, $h) = @_;
	    eval q( &PATH_OFFSET_POSITION ($path,  ($path->{path_length}) - ($h)));
    }' unless defined(&PATH_H_POSITION);
    eval 'sub PATH_H_B_ITEM_ORDER {
        local($path, $h) = @_;
	    eval q( &PATH_H_POSITION($path, $h + 1));
    }' unless defined(&PATH_H_B_ITEM_ORDER);
    eval 'sub PATH_H_PATH_OFFSET {
        local($p_s_path, $n_h) = @_;
	    eval q((($p_s_path)-> &path_length - ($n_h)));
    }' unless defined(&PATH_H_PATH_OFFSET);
    eval 'sub UNFM_P_SIZE () {($sizeof{\'unsigned long\'});}' unless defined(&UNFM_P_SIZE);
    eval 'sub INODE_PKEY {
        local($inode) = @_;
	    eval q(((($inode)-> ($u->{reiserfs_i}->{i_key}))));
    }' unless defined(&INODE_PKEY);
    if(defined(&REISERFS_CHECK)) {
    }
    eval 'sub BH_Suspected_Recipient () {12;}' unless defined(&BH_Suspected_Recipient);
    eval 'sub BH_Unwritten () {13;}' unless defined(&BH_Unwritten);
    eval 'sub BH_Preserved () {14;}' unless defined(&BH_Preserved);
    eval 'sub PRESERVE_DIRECT_TO_INDIRECT () {1;}' unless defined(&PRESERVE_DIRECT_TO_INDIRECT);
    eval 'sub PRESERVE_INDIRECT_TO_DIRECT () {2;}' unless defined(&PRESERVE_INDIRECT_TO_DIRECT);
    eval 'sub PRESERVE_RENAMING () {3;}' unless defined(&PRESERVE_RENAMING);
    eval 'sub NOTHING_SPECIAL () {4;}' unless defined(&NOTHING_SPECIAL);
    eval 'sub PRESERVE_LIST_WAS_EMPTY () {0;}' unless defined(&PRESERVE_LIST_WAS_EMPTY);
    eval 'sub FEW_BLOCKS_ARE_FREED () {1;}' unless defined(&FEW_BLOCKS_ARE_FREED);
    eval 'sub MAX_UL_INT () {0xffffffff;}' unless defined(&MAX_UL_INT);
    eval 'sub MAX_INT () {0x7ffffff;}' unless defined(&MAX_INT);
    eval 'sub MAX_US_INT () {0xffff;}' unless defined(&MAX_US_INT);
    eval 'sub MAX_KEY_OFFSET () { &MAX_UL_INT;}' unless defined(&MAX_KEY_OFFSET);
    eval 'sub MAX_KEY_UNIQUENESS () { &MAX_UL_INT;}' unless defined(&MAX_KEY_UNIQUENESS);
    eval 'sub MAX_KEY_OBJECTID () { &MAX_UL_INT;}' unless defined(&MAX_KEY_OBJECTID);
    eval 'sub MAX_B_NUM () { &MAX_UL_INT;}' unless defined(&MAX_B_NUM);
    eval 'sub MAX_FC_NUM () { &MAX_US_INT;}' unless defined(&MAX_FC_NUM);
    eval 'sub REISERFS_LINK_MAX () {( &MAX_US_INT - 1000);}' unless defined(&REISERFS_LINK_MAX);
    eval 'sub REISERFS_KERNEL_MEM () {0;}' unless defined(&REISERFS_KERNEL_MEM);
    eval 'sub REISERFS_USER_MEM () {1;}' unless defined(&REISERFS_USER_MEM);
    eval 'sub VI_TYPE_STAT_DATA () {1;}' unless defined(&VI_TYPE_STAT_DATA);
    eval 'sub VI_TYPE_DIRECT () {2;}' unless defined(&VI_TYPE_DIRECT);
    eval 'sub VI_TYPE_INDIRECT () {4;}' unless defined(&VI_TYPE_INDIRECT);
    eval 'sub VI_TYPE_DIRECTORY () {8;}' unless defined(&VI_TYPE_DIRECTORY);
    eval 'sub VI_TYPE_FIRST_DIRECTORY_ITEM () {16;}' unless defined(&VI_TYPE_FIRST_DIRECTORY_ITEM);
    eval 'sub VI_TYPE_INSERTED_DIRECTORY_ITEM () {32;}' unless defined(&VI_TYPE_INSERTED_DIRECTORY_ITEM);
    eval 'sub VI_TYPE_LEFT_MERGEABLE () {64;}' unless defined(&VI_TYPE_LEFT_MERGEABLE);
    eval 'sub VI_TYPE_RIGHT_MERGEABLE () {128;}' unless defined(&VI_TYPE_RIGHT_MERGEABLE);
    eval 'sub MAX_FREE_BLOCK () {7;}' unless defined(&MAX_FREE_BLOCK);
    eval 'sub MAX_PRESERVE_NODES () {2;}' unless defined(&MAX_PRESERVE_NODES);
    eval 'sub MAX_AMOUNT_NEEDED () {2;}' unless defined(&MAX_AMOUNT_NEEDED);
    eval 'sub DIRTY_BITMAP_MAP {
        local($tb) = @_;
	    eval q((($tb)-> &vn_buf));
    }' unless defined(&DIRTY_BITMAP_MAP);
    if(0) {
    }
    eval 'sub M_INSERT () {ord(\'i\');}' unless defined(&M_INSERT);
    eval 'sub M_PASTE () {ord(\'p\');}' unless defined(&M_PASTE);
    eval 'sub M_DELETE () {ord(\'d\');}' unless defined(&M_DELETE);
    eval 'sub M_CUT () {ord(\'c\');}' unless defined(&M_CUT);
    eval 'sub M_INTERNAL () {ord(\'n\');}' unless defined(&M_INTERNAL);
    eval 'sub M_SKIP_BALANCING () {ord(\'s\');}' unless defined(&M_SKIP_BALANCING);
    eval 'sub M_CONVERT () {ord(\'v\');}' unless defined(&M_CONVERT);
    eval 'sub LEAF_FROM_S_TO_L () {0;}' unless defined(&LEAF_FROM_S_TO_L);
    eval 'sub LEAF_FROM_S_TO_R () {1;}' unless defined(&LEAF_FROM_S_TO_R);
    eval 'sub LEAF_FROM_R_TO_L () {2;}' unless defined(&LEAF_FROM_R_TO_L);
    eval 'sub LEAF_FROM_L_TO_R () {3;}' unless defined(&LEAF_FROM_L_TO_R);
    eval 'sub LEAF_FROM_S_TO_SNEW () {4;}' unless defined(&LEAF_FROM_S_TO_SNEW);
    eval 'sub FIRST_TO_LAST () {0;}' unless defined(&FIRST_TO_LAST);
    eval 'sub LAST_TO_FIRST () {1;}' unless defined(&LAST_TO_FIRST);
    eval 'sub TYPE_STAT_DATA () {0x0;}' unless defined(&TYPE_STAT_DATA);
    eval 'sub TYPE_DIRECT () {0xffffffff;}' unless defined(&TYPE_DIRECT);
    eval 'sub TYPE_INDIRECT () {0xfffffffe;}' unless defined(&TYPE_INDIRECT);
    eval 'sub TYPE_DIRECTORY_MAX () {0xfffffffd;}' unless defined(&TYPE_DIRECTORY_MAX);
    eval 'sub KEY_IS_STAT_DATA_KEY {
        local($p_s_key) = @_;
	    eval q(( ($p_s_key)-> &k_uniqueness ==  &TYPE_STAT_DATA ));
    }' unless defined(&KEY_IS_STAT_DATA_KEY);
    eval 'sub KEY_IS_DIRECTORY_KEY {
        local($p_s_key) = @_;
	    eval q(( ($p_s_key)-> &k_uniqueness ==  &DIRENTRY_UNIQUENESS ));
    }' unless defined(&KEY_IS_DIRECTORY_KEY);
    eval 'sub KEY_IS_DIRECT_KEY {
        local($p_s_key) = @_;
	    eval q(( ($p_s_key)-> &k_uniqueness ==  &TYPE_DIRECT ));
    }' unless defined(&KEY_IS_DIRECT_KEY);
    eval 'sub KEY_IS_INDIRECT_KEY {
        local($p_s_key) = @_;
	    eval q(( ($p_s_key)-> &k_uniqueness ==  &TYPE_INDIRECT ));
    }' unless defined(&KEY_IS_INDIRECT_KEY);
    eval 'sub I_IS_STAT_DATA_ITEM {
        local($p_s_ih) = @_;
	    eval q( &KEY_IS_STAT_DATA_KEY((($p_s_ih)-> &ih_key)));
    }' unless defined(&I_IS_STAT_DATA_ITEM);
    eval 'sub I_IS_DIRECTORY_ITEM {
        local($p_s_ih) = @_;
	    eval q( &KEY_IS_DIRECTORY_KEY((($p_s_ih)-> &ih_key)));
    }' unless defined(&I_IS_DIRECTORY_ITEM);
    eval 'sub I_IS_DIRECT_ITEM {
        local($p_s_ih) = @_;
	    eval q( &KEY_IS_DIRECT_KEY((($p_s_ih)-> &ih_key)));
    }' unless defined(&I_IS_DIRECT_ITEM);
    eval 'sub I_IS_INDIRECT_ITEM {
        local($p_s_ih) = @_;
	    eval q( &KEY_IS_INDIRECT_KEY((($p_s_ih)-> &ih_key)));
    }' unless defined(&I_IS_INDIRECT_ITEM);
    eval 'sub COMP_KEYS () { &comp_keys;}' unless defined(&COMP_KEYS);
    eval 'sub COMP_SHORT_KEYS () { &comp_short_keys;}' unless defined(&COMP_SHORT_KEYS);
    eval 'sub I_UNFM_NUM {
        local($p_s_ih) = @_;
	    eval q(( ($p_s_ih)-> &ih_item_len /  &UNFM_P_SIZE ));
    }' unless defined(&I_UNFM_NUM);
    eval 'sub I_POS_UNFM_SIZE {
        local($ih,$pos,$size) = @_;
	    eval q(((($pos) ==  &I_UNFM_NUM($ih) - 1) ? ($size) - ($ih)-> ($u->{ih_free_space}) : ($size)));
    }' unless defined(&I_POS_UNFM_SIZE);
    eval 'sub I_BYTES_NUMBER {
        local($ih,$size) = @_;
	    eval q(((  &I_IS_INDIRECT_ITEM($ih) ) ?  &I_UNFM_NUM($ih)*$size - ($ih)-> ($u->{ih_free_space}) : ((  &I_IS_DIRECT_ITEM($ih) ) ? ($ih)-> &ih_item_len : 0)));
    }' unless defined(&I_BYTES_NUMBER);
    eval 'sub I_OFF_BYTE_IN_ITEM {
        local($p_s_ih, $n_offset, $n_blocksize) = @_;
	    eval q(( ($p_s_ih)-> ($ih_key->{k_offset}) <= ($n_offset)  && ($p_s_ih)-> ($ih_key->{k_offset}) +  &I_BYTES_NUMBER($p_s_ih,$n_blocksize) > ($n_offset) ));
    }' unless defined(&I_OFF_BYTE_IN_ITEM);
    eval 'sub B_N_PITEM_HEAD {
        local($bh,$item_num) = @_;
	    eval q(( (($bh)-> &b_data +  &BLKH_SIZE) + ($item_num) ));
    }' unless defined(&B_N_PITEM_HEAD);
    eval 'sub B_N_PDELIM_KEY {
        local($bh,$item_num) = @_;
	    eval q(( (($bh)-> &b_data +  &BLKH_SIZE) + ($item_num) ));
    }' unless defined(&B_N_PDELIM_KEY);
    eval 'sub B_N_PKEY {
        local($bh,$item_num) = @_;
	    eval q(( ( &B_N_PITEM_HEAD($bh,$item_num)-> &ih_key) ));
    }' unless defined(&B_N_PKEY);
    eval 'sub B_N_PITEM {
        local($bh,$item_num) = @_;
	    eval q(( ($bh)-> &b_data +  &B_N_PITEM_HEAD(($bh),($item_num))-> &ih_item_location));
    }' unless defined(&B_N_PITEM);
    eval 'sub B_N_STAT_DATA {
        local($bh,$nr) = @_;
	    eval q(( (($bh)-> &b_data+ &B_N_PITEM_HEAD(($bh),($nr))-> &ih_item_location ) ));
    }' unless defined(&B_N_STAT_DATA);
    eval 'sub B_I_PITEM {
        local($bh,$ih) = @_;
	    eval q(( ($bh)-> &b_data + ($ih)-> &ih_item_location ));
    }' unless defined(&B_I_PITEM);
    eval 'sub B_I_STAT_DATA {
        local($bh, $ih) = @_;
	    eval q(( (($bh)-> &b_data + ($ih)-> &ih_item_location) ));
    }' unless defined(&B_I_STAT_DATA);
    eval 'sub MAX_DIRECT_ITEM_LEN {
        local($size) = @_;
	    eval q((($size) -  &BLKH_SIZE - 2* &IH_SIZE -  &SD_SIZE -  &UNFM_P_SIZE));
    }' unless defined(&MAX_DIRECT_ITEM_LEN);
    eval 'sub B_I_POS_UNFM_POINTER {
        local($bh,$ih,$pos) = @_;
	    eval q((*(( &B_I_PITEM($bh,$ih)) + ($pos))));
    }' unless defined(&B_I_POS_UNFM_POINTER);
    if(defined(&REISERFS_CACHE_STAT)) {
    }
    eval 'sub JOURNAL_TRANS_HALF () {1018;}' unless defined(&JOURNAL_TRANS_HALF);
    eval 'sub JOURNAL_BLOCK_COUNT () {8192;}' unless defined(&JOURNAL_BLOCK_COUNT);
    if(defined(&__KERNEL__)) {
	eval 'sub JOURNAL_MAX_BATCH () {900;}' unless defined(&JOURNAL_MAX_BATCH);
	eval 'sub JOURNAL_MAX_COMMIT_AGE () {30;}' unless defined(&JOURNAL_MAX_COMMIT_AGE);
	eval 'sub JOURNAL_MAX_TRANS_AGE () {30;}' unless defined(&JOURNAL_MAX_TRANS_AGE);
	eval 'sub JOURNAL_PER_BALANCE_CNT () {12;}' unless defined(&JOURNAL_PER_BALANCE_CNT);
	eval 'sub REISERFS_MIN_BITMAP_NODES () {10;}' unless defined(&REISERFS_MIN_BITMAP_NODES);
	eval 'sub REISERFS_MAX_BITMAP_NODES () {100;}' unless defined(&REISERFS_MAX_BITMAP_NODES);
	eval 'sub JOURNAL_UNMOUNTING () {1;}' unless defined(&JOURNAL_UNMOUNTING);
	eval 'sub JHASHDEV {
	    local($d) = @_;
    	    eval q(( ($d)));
	}' unless defined(&JHASHDEV);
	eval 'sub _jhashfn {
	    local($dev,$block) = @_;
    	    eval q(((( &JHASHDEV($dev)^($block))) %  &JOURNAL_HASH_SIZE));
	}' unless defined(&_jhashfn);
	eval 'sub journal_hash {
	    local($t,$dev,$block) = @_;
    	    eval q((($t)[ &_jhashfn(($dev),($block))]));
	}' unless defined(&journal_hash);
	eval 'sub JOURNAL_BUFFER {
	    local($j,$n) = @_;
    	    eval q((($j)-> $j_ap_blocks[(($j)-> &j_start + ($n)) %  &JOURNAL_BLOCK_COUNT]));
	}' unless defined(&JOURNAL_BUFFER);
    }
    if(defined(&__KERNEL__)) {
    }
    unless(defined(&REISERFS_FSCK)) {
    } else {
    }
    if(defined(&__KERNEL__)) {
    }
    eval 'sub PRINT_LEAF_ITEMS () {1;}' unless defined(&PRINT_LEAF_ITEMS);
    eval 'sub PRINT_DIRECTORY_ITEMS () {2;}' unless defined(&PRINT_DIRECTORY_ITEMS);
    eval 'sub PRINT_DIRECT_ITEMS () {4;}' unless defined(&PRINT_DIRECT_ITEMS);
    if(defined(&REISERFS_CHECK)) {
    }
    eval 'sub COMPLETE_BITMAP_DIRTING_AFTER_ALLOCATING {
        local($s,$bitmapnr) = @_;
	    eval q( &SB_AP_BITMAP($s)[$bitmapnr]-> &b_count ++;  &brelse ( &SB_AP_BITMAP($s)[$bitmapnr]);  &SB_BUFFER_WITH_SB ($s)-> &b_count ++;  &brelse ( &SB_BUFFER_WITH_SB ($s)););
    }' unless defined(&COMPLETE_BITMAP_DIRTING_AFTER_ALLOCATING);
    eval 'sub COMPLETE_BITMAP_DIRTING_AFTER_FREEING {
        local($s,$bitmapnr) = @_;
	    eval q( &SB_AP_BITMAP($s)[$bitmapnr]-> &b_count ++;  &brelse ( &SB_AP_BITMAP($s)[$bitmapnr]);  &SB_BUFFER_WITH_SB ($s)-> &b_count ++;  &brelse ( &SB_BUFFER_WITH_SB ($s)););
    }' unless defined(&COMPLETE_BITMAP_DIRTING_AFTER_FREEING);
    if(defined(&__i386__)) {
    } else {
	eval 'sub find_first_nonzero_bit {
	    local($addr,$size) = @_;
    	    eval q( &find_next_nonzero_bit(($addr), ($size), 0));
	}' unless defined(&find_first_nonzero_bit);
    }
    if(defined(&__KERNEL__)) {
    }
    eval 'sub REISERFS_IOC_UNPACK () { &_IOW(0xcd,1,\'long\');}' unless defined(&REISERFS_IOC_UNPACK);
}
1;
